/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   dnac.c
   compress DNA sequences storing 4 bases in one byte.
   the output is sent to stdout.
   use dnau to decompress 
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */ 
#include <stdio.h>
#include <stdlib.h>


#define output(X) putchar(X)


int main(int argc, char **argv)
{
  int c,i,v,b,fsize;
  FILE *f;


  // check that a file name was provided on the command line
  if(argc!=2) {
    fprintf(stderr,"Usage:\n\t%s input_file > output_file\n",argv[0]);
    exit(1);
  }
  // open file
  f = fopen( argv[1], "rb"); // b is for binary: required by DOS/WINDOWS
  if(f==NULL) {
    perror(argv[1]);
    exit(2);
  }
  // get file length
  fseek(f, 0, SEEK_END);
  fsize=ftell(f);
  rewind(f);
  // write file length
  for(i=0;i<32;i+=8)
    output( (fsize >> i) & 0xFF);
  // start compression
  i=0;b=0;
  while((c=getc(f))!=EOF) {
    switch (c) {
      case 'a':
      case 'A':
	v=0; break;
      case 'c':
      case 'C':
	v=1; break;
      case 'g':
      case 'G':
	v=2; break;
      case 't':
      case 'T':
	v=3; break;
    default:
      fprintf(stderr,"Illegal input char\n");
      exit(1);
    }
    b += (v<<(6-i));
    if(i==6) {
      output(b);
      i=0; b=0;
    }
    else i+= 2;
  }
  // flush buffer and we are done!
  if(i>0) output(b);
  return 0;
}
