/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
   dnau.c
   decompress DNA sequences stored with 4 bases in one byte.
   the output is sent to stdout.
   use dnac do compress
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */ 
#include <stdio.h>
#include <stdlib.h>

#define output(X) putchar(X)


int main(int argc, char **argv)
{
  int c,i,v,size=0;
  char b;
  FILE *f;

  // if a filename was provided on the command line use it
  if(argc==2) {
    f = fopen( argv[1], "rb"); // b is for binary: required by DOS/WINDOWS
    if(f==NULL) {
      perror(argv[1]);
      exit(2);
    }
  } 
  // if no argument was given use stdin
  else if(argc==1) {
    f = stdin;
  }
  // otherwise print usage information 
  else { 
    fprintf(stderr,"Usage:\n\t%s [input_file] > output_file\n",argv[0]);
    fprintf(stderr,"\tIf no input file is given stdin is used\n");
    exit(1);
  }

  // get number of bases
  for(i=0;i<32;i+=8) {
    c = getc(f);
    size += (c<<i);
  }
  // do the actual decompression
  i=0;b=0;
  while((c=getc(f))!=EOF) {
    for(i=6;i>=0;i-=2) {
      v = (c>>i) & 3;
      switch (v) {
      case 0:
	b='a'; break;
      case 1:
	b='c'; break;
      case 2:
	b='g'; break;
      case 3:
	b='t'; break;
      default:
	fprintf(stderr,"Something is wrong\n");
	exit(1);
      }
      output(b);
      if(--size==0) exit(0);
    }
  }
  return 0;
}
